unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, IdBaseComponent, IdComponent, IdUDPBase, IdUDPClient, IdSNTP,
  StdCtrls, ComCtrls, ExtCtrls, Menus, AppEvnts;

type
  TForm1 = class(TForm)
    IdSNTP1: TIdSNTP;
    lv_serv: TListView;
    Timer1: TTimer;
    pop_task: TPopupMenu;
    Open1: TMenuItem;
    Synchronize1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    stb_main: TStatusBar;
    MainMenu1: TMainMenu;
    Synchronizeit1: TMenuItem;
    N2: TMenuItem;
    Exit2: TMenuItem;
    Synchronizeit2: TMenuItem;
    pan_prg: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Exit2Click(Sender: TObject);
    procedure Synchronizeit2Click(Sender: TObject);
  private
    { Private declarations }
    FTick:integer;
    procedure ResetTimer;
  public
    { Public declarations }
    procedure WMSysCommand(var Msg: TWMSysCommand); message WM_SYSCOMMAND;
  end;

var
  Form1: TForm1;

implementation

uses k3ks_tasktools;

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var p,i:integer;s,s2:string;
begin
 CreateTaskIconOfApplication(Self,Pop_Task,0,3);
 stb_main.Panels[1].Text:='';
 ResetTimer;
 with TStringList.Create do begin
  try
   lv_serv.Clear;
   LoadFromFile('ntpservlist.ini');
   for i:=0 to (Count div 2)-1 do begin
    s:=Strings[i*2];
    s2:=Strings[i*2+1];
    with lv_serv.Items.Add do begin
     Caption:=s;
     SubItems.Add(s2)
    end;
   end;
  finally
   Free;
  end;
 end;

 {with TStringList.Create do begin
  try
   LoadFromFile('ntpservlist1.txt');
   for i:=0 to Count-1 do begin
    s:=Strings[i];
    if Copy(s,1,2)=AnsiUpperCase(Copy(s,1,2)) then
     if Copy(s,3,1)=' ' then
      if (s[1] in ['A'..'Z']) then begin
       p:=pos('(',s);
       if (p<>0) then begin
        System.delete(s,1,p);
        p:=pos(')',s);
        if (p<>0) then begin
         s:=copy(s,1,p-1);
         if (s[1] in ['0'..'9']) then begin
          s2:=Strings[i];
          p:=pos('(',s2);
          s2:=Trim(Copy(s2,1,p-1));
          ListBox1.Items.Add(s2);
          ListBox1.Items.Add(s);
         end;
        end;
       end;
      end;
   end;
   ListBox1.Items.SaveToFile('ntpservlist.ini');
  finally
   Free;
  end;
 end;}
end;

procedure TForm1.Button1Click(Sender: TObject);
var i:integer;
begin
 pan_prg.Visible:=True;
 Repaint;
 try
  for i:=0 to lv_serv.Items.Count-1 do begin
   IdSNTP1.Host:=Trim(lv_serv.Items[i].SubItems.Text);
   IdSNTP1.ReceiveTimeout:=MSecsPerSec*10;
   if IdSNTP1.SyncTime then begin
    stb_main.Panels[1].Text:='New synchronized time is: '+DateTimeToStr(Now);
    break;
   end else stb_main.Panels[1].Text:='Error: synchronizing have been failed !';
  end;
 finally
  pan_prg.Visible:=False;
 end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
 if (FTick<=0) then begin
  ResetTimer;
  Button1Click(nil);
 end else Dec(FTick);
 stb_main.Panels[0].Text:='Rem. sec: '+IntToStr(FTick);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 DestroyTaskIcon;
end;

procedure TForm1.WMSysCommand(var Msg: TWMSysCommand);
begin
  if (Msg.CmdType = SC_MINIMIZE) then begin
   // Nothing to do !
  end else DefaultHandler(Msg);
end;

procedure TForm1.ResetTimer;
begin
 Timer1.Enabled:=False;
 FTick:=SecsPerMin*MinsPerHour;
 Timer1.Enabled:=True;
end;

procedure TForm1.Exit2Click(Sender: TObject);
begin
 Self.Close;
end;

procedure TForm1.Synchronizeit2Click(Sender: TObject);
begin
 Button1Click(nil);
end;

end.
